package mpwechat

import (
	base_ctl "SCRM/controllers"
	"SCRM/enums"
	"SCRM/service/wechat_service"

	"encoding/json"

	"github.com/astaxie/beego"
)

func MpMenusCtlRegistRouters() {
	beego.Router("/api/mpwechat/menus", &MpMenusAPIController{}, "Get:GetMenus")
}

type MpMenusAPIController struct {
	base_ctl.BaseAuthAPIController
}

func (c *MpMenusAPIController) GetMenus() {

	adminUserInfo := c.GetAdminUserInfo()

	buttons, err := wechat_service.GetMenusByOrgID(adminUserInfo.CurrentOrgId)
	if err != nil {
		c.ServeFailJsonSend(enums.ErrorCodeDataException, "读取菜单配置信息失败:（"+err.Error()+"）")
		return
	}
	if buttons != nil && buttons.ButtonStatus != 1 {
		buttons = nil
	}

	var menus wechat_service.SelfMenuInfo
	if buttons != nil {
		err = json.Unmarshal([]byte(buttons.ButtonFileds), &menus)
		if err != nil {
			c.ServeFailJsonSend(enums.ErrorCodeDataException, "解析菜单配置信息失败:（"+err.Error()+"）")
			return
		}
	}

	returnData := make(map[string]interface{}, 0)
	returnData["buttons"] = buttons
	returnData["menus"] = menus
	c.ServeSuccessJSON(returnData)
	return
}
